#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK10x76x76NT10x4x1_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=10, NB=76, KB=76, 
 * lda=0, ldb=0, ldc=0, mu=10, nu=4, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + 10;
   const float *stN = B + 76;
   const float *pfA = A + lda*M;
   const int incAk = (lda);
   const int incAm = 10 - (76*(lda)), incAn = -10;
   const int incBk = (ldb), incBm = -(76*(ldb));
   #define incBn 4
   #define incCm 10
   const int incCn = (((ldc) << 2)) - 10;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9;
   register float rB0, rB1, rB2, rB3;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC7_1, rC8_1, rC9_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2, rC7_2, rC8_2, rC9_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3, rC6_3, rC7_3, rC8_3, rC9_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+32);
      pfA += lda;
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      rC0_1 = *pC1;
      rC0_2 = *pC2;
      rC0_3 = *pC3;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
      ATL_pfl1W(pC3);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[1];
      rA2 = pA0[2];
      rA3 = pA0[3];
      rA4 = pA0[4];
      rA5 = pA0[5];
      rC0_0 = rA0 * rB0;
      rA6 = pA0[6];
      rA7 = pA0[7];
      rA8 = pA0[8];
      rA9 = pA0[9];
      rC1_0 = rA1 * rB0;
      rB1 = pB0[1];
      rB2 = pB0[2];
      rB3 = pB0[3];
      rC2_0 = rA2 * rB0;
      rC3_0 = rA3 * rB0;
      rC4_0 = rA4 * rB0;
      rC5_0 = rA5 * rB0;
      rC6_0 = rA6 * rB0;
      rC7_0 = rA7 * rB0;
      rC8_0 = rA8 * rB0;
      rC9_0 = rA9 * rB0;
      rC0_1 = rA0 * rB1;
      rC1_1 = rA1 * rB1;
      rC2_1 = rA2 * rB1;
      rC3_1 = rA3 * rB1;
      rC4_1 = rA4 * rB1;
      rC5_1 = rA5 * rB1;
      rC6_1 = rA6 * rB1;
      rC7_1 = rA7 * rB1;
      rC8_1 = rA8 * rB1;
      rC9_1 = rA9 * rB1;
      rC0_2 = rA0 * rB2;
      rC1_2 = rA1 * rB2;
      rC2_2 = rA2 * rB2;
      rC3_2 = rA3 * rB2;
      rC4_2 = rA4 * rB2;
      rC5_2 = rA5 * rB2;
      rC6_2 = rA6 * rB2;
      rC7_2 = rA7 * rB2;
      rC8_2 = rA8 * rB2;
      rC9_2 = rA9 * rB2;
      rC0_3 = rA0 * rB3;
      rC1_3 = rA1 * rB3;
      rC2_3 = rA2 * rB3;
      rC3_3 = rA3 * rB3;
      rC4_3 = rA4 * rB3;
      rC5_3 = rA5 * rB3;
      rC6_3 = rA6 * rB3;
      rC7_3 = rA7 * rB3;
      rC8_3 = rA8 * rB3;
      rC9_3 = rA9 * rB3;
      pA0 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=75; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rA5 = pA0[5];
         rC0_0 += rA0 * rB0;
         rA6 = pA0[6];
         rA7 = pA0[7];
         rA8 = pA0[8];
         rA9 = pA0[9];
         rC1_0 += rA1 * rB0;
         rB1 = pB0[1];
         rB2 = pB0[2];
         rB3 = pB0[3];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC8_0 += rA8 * rB0;
         rC9_0 += rA9 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         rC8_1 += rA8 * rB1;
         rC9_1 += rA9 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC5_2 += rA5 * rB2;
         rC6_2 += rA6 * rB2;
         rC7_2 += rA7 * rB2;
         rC8_2 += rA8 * rB2;
         rC9_2 += rA9 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         rC5_3 += rA5 * rB3;
         rC6_3 += rA6 * rB3;
         rC7_3 += rA7 * rB3;
         rC8_3 += rA8 * rB3;
         rC9_3 += rA9 * rB3;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0[2] = rC2_0;
      pC0[3] = rC3_0;
      pC0[4] = rC4_0;
      pC0[5] = rC5_0;
      pC0[6] = rC6_0;
      pC0[7] = rC7_0;
      pC0[8] = rC8_0;
      pC0[9] = rC9_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      pC1[2] = rC2_1;
      pC1[3] = rC3_1;
      pC1[4] = rC4_1;
      pC1[5] = rC5_1;
      pC1[6] = rC6_1;
      pC1[7] = rC7_1;
      pC1[8] = rC8_1;
      pC1[9] = rC9_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      pC2[2] = rC2_2;
      pC2[3] = rC3_2;
      pC2[4] = rC4_2;
      pC2[5] = rC5_2;
      pC2[6] = rC6_2;
      pC2[7] = rC7_2;
      pC2[8] = rC8_2;
      pC2[9] = rC9_2;
      *pC3 = rC0_3;
      pC3[1] = rC1_3;
      pC3[2] = rC2_3;
      pC3[3] = rC3_3;
      pC3[4] = rC4_3;
      pC3[5] = rC5_3;
      pC3[6] = rC6_3;
      pC3[7] = rC7_3;
      pC3[8] = rC8_3;
      pC3[9] = rC9_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK76x76x76NT0x0x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=76, NB=76, KB=76, 
 * lda=0, ldb=0, ldc=0, mu=11, nu=4, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 66;
   const float *stN = B + 76;
   const float *pfA = A + lda*M;
   const int incAk = (lda);
   const int incAm = 11 - (76*(lda)), incAn = -66;
   const int incBk = (ldb), incBm = -(76*(ldb));
   #define incBn 4
   #define incCm 11
   const int incCn = (((ldc) << 2)) - 66;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10;
   register float rB0, rB1, rB2, rB3;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC7_1, rC8_1, rC9_1, rC10_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2, rC7_2, rC8_2, rC9_2, rC10_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3, rC6_3, rC7_3, rC8_3, rC9_3, rC10_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rA5 = pA0[5];
         rC0_0 = rA0 * rB0;
         rA6 = pA0[6];
         rA7 = pA0[7];
         rA8 = pA0[8];
         rA9 = pA0[9];
         rC1_0 = rA1 * rB0;
         rA10 = pA0[10];
         rB1 = pB0[1];
         rB2 = pB0[2];
         rB3 = pB0[3];
         rC2_0 = rA2 * rB0;
         rC3_0 = rA3 * rB0;
         rC4_0 = rA4 * rB0;
         rC5_0 = rA5 * rB0;
         rC6_0 = rA6 * rB0;
         rC7_0 = rA7 * rB0;
         rC8_0 = rA8 * rB0;
         rC9_0 = rA9 * rB0;
         rC10_0 = rA10 * rB0;
         rC0_1 = rA0 * rB1;
         rC1_1 = rA1 * rB1;
         rC2_1 = rA2 * rB1;
         rC3_1 = rA3 * rB1;
         rC4_1 = rA4 * rB1;
         rC5_1 = rA5 * rB1;
         rC6_1 = rA6 * rB1;
         rC7_1 = rA7 * rB1;
         rC8_1 = rA8 * rB1;
         rC9_1 = rA9 * rB1;
         rC10_1 = rA10 * rB1;
         rC0_2 = rA0 * rB2;
         rC1_2 = rA1 * rB2;
         rC2_2 = rA2 * rB2;
         rC3_2 = rA3 * rB2;
         rC4_2 = rA4 * rB2;
         rC5_2 = rA5 * rB2;
         rC6_2 = rA6 * rB2;
         rC7_2 = rA7 * rB2;
         rC8_2 = rA8 * rB2;
         rC9_2 = rA9 * rB2;
         rC10_2 = rA10 * rB2;
         rC0_3 = rA0 * rB3;
         rC1_3 = rA1 * rB3;
         rC2_3 = rA2 * rB3;
         rC3_3 = rA3 * rB3;
         rC4_3 = rA4 * rB3;
         rC5_3 = rA5 * rB3;
         rC6_3 = rA6 * rB3;
         rC7_3 = rA7 * rB3;
         rC8_3 = rA8 * rB3;
         rC9_3 = rA9 * rB3;
         rC10_3 = rA10 * rB3;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=75; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rC0_0 += rA0 * rB0;
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            rA9 = pA0[9];
            rC1_0 += rA1 * rB0;
            rA10 = pA0[10];
            rB1 = pB0[1];
            rB2 = pB0[2];
            rB3 = pB0[3];
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC7_1 += rA7 * rB1;
            rC8_1 += rA8 * rB1;
            rC9_1 += rA9 * rB1;
            rC10_1 += rA10 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC3_2 += rA3 * rB2;
            rC4_2 += rA4 * rB2;
            rC5_2 += rA5 * rB2;
            rC6_2 += rA6 * rB2;
            rC7_2 += rA7 * rB2;
            rC8_2 += rA8 * rB2;
            rC9_2 += rA9 * rB2;
            rC10_2 += rA10 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC3_3 += rA3 * rB3;
            rC4_3 += rA4 * rB3;
            rC5_3 += rA5 * rB3;
            rC6_3 += rA6 * rB3;
            rC7_3 += rA7 * rB3;
            rC8_3 += rA8 * rB3;
            rC9_3 += rA9 * rB3;
            rC10_3 += rA10 * rB3;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         pC0[5] = rC5_0;
         pC0[6] = rC6_0;
         pC0[7] = rC7_0;
         pC0[8] = rC8_0;
         pC0[9] = rC9_0;
         pC0[10] = rC10_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         pC1[4] = rC4_1;
         pC1[5] = rC5_1;
         pC1[6] = rC6_1;
         pC1[7] = rC7_1;
         pC1[8] = rC8_1;
         pC1[9] = rC9_1;
         pC1[10] = rC10_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         pC2[4] = rC4_2;
         pC2[5] = rC5_2;
         pC2[6] = rC6_2;
         pC2[7] = rC7_2;
         pC2[8] = rC8_2;
         pC2[9] = rC9_2;
         pC2[10] = rC10_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         pC3[3] = rC3_3;
         pC3[4] = rC4_3;
         pC3[5] = rC5_3;
         pC3[6] = rC6_3;
         pC3[7] = rC7_3;
         pC3[8] = rC8_3;
         pC3[9] = rC9_3;
         pC3[10] = rC10_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_sJIK10x76x76NT10x4x1_a1_b0(10, 76, 76, alpha, ca + 66, lda, cb, ldb, beta, cc + 66, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
